.shopping-cart {
  --cart-counter-bg-color: var(--primary-rounded-button-bg-color);
  --cart-counter-color: var(--primary-rounded-button-text-color);
  --cart-bg-color: var(--popup-bg-color);
  --soldout-color: var(--error-color);
  --original-price-sale-color: var(--tertiary-text-color);
  --sale-color: var(--primary-text-color);
  --max-quantity-color: var(--error-color);
  --minimum-order-error-color: var(--error-color);
}

body:has(.cart-overview-items[aria-busy="true"]) .cart-items {
  pointer-events: none;
  opacity: 0.5;
}

body:has(.cart-dialog[open]) {
  overflow: hidden;
}

.cart-item.template {
  display: none;
}

.toggle-cart {
  display: flex;
  position: relative;

  &:after {
    mask-image: url('../../assets/icons/cart.svg');
    display: block;
  }

  &[data-items="0"]:before {
    display: none;
  }

  &:before {
    content: attr(data-items);
    display: flex;
    justify-content: center;
    align-items: center;
    position: absolute;
    top: -0.5rem;
    right: -0.5rem;
    z-index: 1;
    background-color: var(--cart-counter-bg-color);
    color: var(--cart-counter-color);
    min-height: 1rem;
    min-width: 1rem;
    width: 1rem;
    height: 1rem;
    border-radius: 100%;
    padding: 0.5rem;
    letter-spacing: 0;
  }
}

.cart-dialog {
  max-width: 30rem;
  max-height: 100%;
  height: 100%;
  width: 100%;
  justify-self: end;
  border: var(--border-primary);

  &::backdrop {
    background-color: var(--backdrop-bg-color);
  }

  @supports (transition-behavior: allow-discrete) {
    transition: transform 0.3s, overlay 0.3s, display 0.3s;
    transition-behavior: allow-discrete;
    transform: translateX(100%);
  }

  &[open] {
    display: flex;

    @supports (transition-behavior: allow-discrete) {
      transform: translateX(0);

      @starting-style {
        transform: translateX(100%);
      }
    }
  }
}

.cart-container {
  display: flex;
  flex-direction: column;
  row-gap: 2rem;
  padding: 2rem;
  background-color: var(--cart-bg-color);
  width: 100%;
}

.cart-container:has(.cart-items[data-items="0"]) :is(.checkout-button, .cart-total, .cart-fulfillment-container) {
  display: none;
}

.cart-dialog:has(.cart-items[data-items="0"]) .empty-cart-message {
  display: flex;
  padding-block: 2rem;
  justify-content: center;
  text-align: center;
}

.empty-cart-message {
  display: none;
}

.cart-items {
  overflow: auto;
  scrollbar-width: thin;

  &[data-items="0"] {
    display: none;
  }
}

.cart-items[aria-busy="true"] {
  opacity: 0.5;
  pointer-events: none;
}

.cart-header {
  display: flex;
  flex-direction: column;
  border-bottom: var(--border-secondary);
  padding-bottom: 1rem;
}

.cart-title-container {
  display: flex;
  justify-content: space-between;
  column-gap: 1rem;
  align-items: center;
  /* border-bottom: var(--border-secondary); */
  /* padding-bottom: 1rem; */
}

.close-cart {
  display: flex;

  &:after {
    display: block;
    mask-image: url('../../assets/icons/close.svg');
  }
}

.cart-items {
  display: flex;
  flex-direction: column;
  row-gap: 3rem;
}

.cart-item {
  display: grid;
  grid-template-columns: minmax(0, 5rem) 1fr;
  column-gap: 1rem;

  &[data-stockquantity="0"] .cart-item-sold-out {
    display: flex;
  }

  &[data-stockquantity="0"] .cart-item-quantity-controls {
    display: none;
  }

  @media (width >= 56.25rem) {
    column-gap: 2rem;
  }
}

.cart-item-link {
  display: flex;
  height: fit-content;
}

.cart-item-variations:has(.cart-item-variation-label:empty, .cart-item-variation-value:empty) {
  display: none;
}

.cart-item-variations {
  display: flex;
  flex-direction: column;
}

.cart-item-container {
  display: flex;
  flex-direction: column;
  width: 100%;
  row-gap: 1rem;
  justify-content: space-between;
}

.cart-item hgroup {
  row-gap: 0;
}

.cart-item-title-container {
  display: flex;
  column-gap: 1rem;
  justify-content: space-between;
  row-gap: 0.5rem;
  flex-direction: column;
}

.cart-item-name-text {
  font-weight: var(--font-weight-semibold);
  text-decoration: underline;
  text-decoration-color: transparent;
  text-underline-offset: 0.25rem;
  transition: text-decoration-color 0.3s;
  text-align: start;

  &:hover {
    text-decoration-color: currentColor;
  }
}

.cart-item-comment:has(.cart-item-comment-value:empty) {
  display: none;
}

.cart-item-price {
  display: flex;
  column-gap: 0.5rem;
  text-align: start;
  flex-wrap: wrap;

  &:has(.cart-item-sale-price:not(:empty)) .cart-item-original-price {
    text-decoration: line-through;
    color: var(--original-price-sale-color);
  }
}

.cart-item-sale-price {
  color: var(--sale-color);
  
  &:empty {
    display: none;
  }
}

.cart-item-quantity-container {
  display: flex;
  column-gap: 1rem;
  align-items: center;
  flex-wrap: wrap;
  row-gap: 0.5rem;
}

.cart-item-sold-out {
  font-weight: var(--font-weight-semibold);
  color: var(--soldout-color);
  display: none;
  column-gap: 1rem;
  align-items: center;

  &:before {
    display: block;
    mask-image: url('../../assets/icons/warning.svg');
  }
}

.cart-item-image {
  object-fit: cover;
  aspect-ratio: 1 / 1;
  transition: opacity 0.3s;
  width: 100%;

  &:hover {
    opacity: 0.5;
  }
}

.cart-item-remove {
  display: flex;
  padding: 0.25rem;

  &:after {
    display: block;
    mask-image: url('../../assets/icons/trash.svg');
    width: 1rem;
    height: 1rem;
    min-width: 1rem;
    min-height: 1rem;
  }
}

.cart-container .cart-footer {
  display: flex;
  flex-direction: column;
  row-gap: 0.5rem;
  width: 100%;
  border-top: var(--border-secondary);
  padding-top: 1.5rem;
  margin-top: auto;
}

.cart-container .button-container {
  display: flex;
  flex-direction: column;
  row-gap: 1rem;
  width: 100%;
  padding-top: 1rem; 
}

.cart-container .button-container .button {
  width: 100%;
}

.cart-container:has(.cart-items[aria-busy="true"]) .button-container {
  pointer-events: none;
  opacity: 0.5;
}

.cart-container .checkout-button:before {
  display: block;
  mask-image: url('../../assets/icons/lock.svg');
}

.cart-container:has(.cart-item[data-stockquantity="0"]) .checkout-button {
  opacity: 0.5;
  pointer-events: none;
}

.cart-item-quantity-controls {
  display: flex;
  align-items: center;
  border: var(--border-secondary);
  width: fit-content;
}

.cart-item-quantity-input {
  text-align: center;
  border: none;
  appearance: textfield;
  height: 100%;
  width: 3ch;

  &::-webkit-inner-spin-button,
  &::-webkit-outer-spin-button {
    -webkit-appearance: none;
    margin: 0;
  }
}

.cart-item-quantity-decrease,
.cart-item-quantity-increase {
  padding: 0.5rem 1rem;
}

.cart-item .max-quantity-message {
  color: var(--max-quantity-color);

  &.hidden {
    display: none;
  }
}

.cart-total {
  display: flex;
  justify-content: space-between;
  width: 100%;
  flex-direction: row;
}

.cart-total-title {
  font-weight: var(--font-weight-semibold);
}

.cart-total-amount {
  font-weight: var(--font-weight-semibold);
}

.cart-fulfillment-container {
  display: flex;
  gap: 1rem;
  align-items: center;
  flex-wrap: wrap;
  padding-top: 1rem;
}

.cart-fulfillment-type {
  display: grid;
  grid-template-columns: 1fr 1fr;
  padding: 0.25rem;
  width: fit-content;
  border-radius: 2rem;
  border: var(--border-secondary);
}

.cart-fulfillment-label {
  width: 100%;
  text-transform: none;
  cursor: pointer;
  border-radius: 2rem;
  padding: 0.5rem;
  text-transform: none;

  &[for="cart-fulfillment-type-pickup"]:before {
    mask-image: url("../../assets/icons/pickup.svg");
    display: block;
  }

  &[for="cart-fulfillment-type-shipping"]:before {
    mask-image: url("../../assets/icons/bicycle.svg");
    display: block;
  }
}

.cart-fulfillment-input:checked + .cart-fulfillment-label {
  background-color: var(--primary-button-bg-color);
  color: var(--primary-button-text-color);
}

.cart-fulfillment-input:focus-visible + .cart-fulfillment-label {
  outline: 2px solid var(--black-100);
  outline-offset: 5px;
}

.cart-shipping-postal-code {
  display: flex;
  column-gap: 0.5rem;
  align-items: center;
  padding: 0.5rem;
  border-radius: 2rem;
  border: var(--border-secondary);
  text-transform: uppercase;
  width: fit-content;
  transition: border-color 0.3s;

  &:hover {
    border-color: currentColor;
  }

  &:empty {
    display: none;
  }

  &:before {
    mask-image: url("../../assets/icons/route.svg");
    display: block;
  }
}

.cart-minimum-error-message {
  color: var(--minimum-order-error-color);
  display: flex;
  column-gap: 0.5rem;
  align-items: center;

  &:empty {
    display: none;
  }

  &:before {
    display: block;
    mask-image: url('../../assets/icons/warning.svg');
  }
}

.cart-dialog:has(#cart-fulfillment-type-pickup:checked) .cart-minimum-error-message {
  display: none;
}